Index: /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/setup_config_from_lmdz.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/setup_config_from_lmdz.F90	(revision 4853)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/setup_config_from_lmdz.F90	(revision 4853)
@@ -0,0 +1,104 @@
+module setup_config_from_lmdz
+
+  use parkind1, only : jprb
+
+  implicit none
+
+  public
+
+  type driver_config_type
+     logical    :: ok_effective_size  = .true.
+     logical    :: ok_separation = .false.   
+     real(jprb) :: high_inv_effective_size   = -1.0_jprb ! m-1
+     real(jprb) :: middle_inv_effective_size = -1.0_jprb ! m-1
+     real(jprb) :: low_inv_effective_size    = -1.0_jprb ! m-1
+     real(jprb) :: cloud_inhom_separation_factor  = -1.0_jprb
+     real(jprb) :: cloud_separation_scale_surface = -1.0_jprb
+     real(jprb) :: cloud_separation_scale_toa     = -1.0_jprb
+     real(jprb) :: cloud_separation_scale_power   = -1.0_jprb
+     real(jprb) :: frac_std = 0.75_jprb
+     real(jprb) :: overlap_decorr_length = 2000.0_jprb
+
+
+ contains
+ procedure :: read => read_config_from_namelist
+
+  end type driver_config_type
+
+contains
+
+  !---------------------------------------------------------------------
+  subroutine read_config_from_namelist(this, file_name, is_success)
+
+    use radiation_io, only : nulerr, radiation_abort       
+
+    class(driver_config_type), intent(inout) :: this
+    character(*), intent(in)          :: file_name
+    logical, intent(out), optional    :: is_success
+    logical    :: ok_effective_size, ok_separation
+    integer    :: iosopen ! Status after calling open
+    real(jprb) :: high_inv_effective_size 
+    real(jprb) :: middle_inv_effective_size
+    real(jprb) :: low_inv_effective_size
+    real(jprb) :: cloud_inhom_separation_factor 
+    real(jprb) :: cloud_separation_scale_surface
+    real(jprb) :: cloud_separation_scale_toa
+    real(jprb) :: cloud_separation_scale_power
+    real(jprb) :: frac_std
+    real(jprb) :: overlap_decorr_length
+
+    namelist /radiation_driver/ ok_effective_size, ok_separation, &
+         &  frac_std, overlap_decorr_length, &
+         &  high_inv_effective_size, middle_inv_effective_size, low_inv_effective_size, &
+         &  cloud_inhom_separation_factor, cloud_separation_scale_surface, &
+         &  cloud_separation_scale_toa, cloud_separation_scale_power 
+
+    ok_effective_size = .false.
+    ok_separation = .false.
+    high_inv_effective_size   = -1.0_jprb 
+    middle_inv_effective_size = -1.0_jprb 
+    low_inv_effective_size    = -1.0_jprb 
+    cloud_inhom_separation_factor  = -1.0_jprb
+    cloud_separation_scale_surface = -1.0_jprb
+    cloud_separation_scale_toa     = -1.0_jprb
+    cloud_separation_scale_power   = -1.0_jprb
+    frac_std = 0.75_jprb
+    overlap_decorr_length = 2000.0_jprb
+
+    ! Open the namelist file and read the radiation_driver namelist
+    open(unit=10, iostat=iosopen, file=trim(file_name))
+    if (iosopen /= 0) then
+      ! An error occurred
+      if (present(is_success)) then
+        is_success = .false.
+        ! We now continue the subroutine so that the default values
+        ! are placed in the config structure
+      else
+        write(nulerr,'(a,a,a)') '*** Error: namelist file "', &
+             &                trim(file_name), '" not found'
+        call radiation_abort('Driver configuration error')
+      end if
+    else
+      ! Read the radiation_driver namelist, noting that it is not an
+      ! error if this namelist is not present, provided all the required
+      ! variables are present in the NetCDF data file instead
+      read(unit=10, nml=radiation_driver)
+      close(unit=10)
+    end if
+
+    ! Copy namelist data into configuration object
+    this%ok_effective_size = ok_effective_size 
+    this%ok_separation = ok_separation
+    this%frac_std = frac_std
+    this%overlap_decorr_length = overlap_decorr_length
+    this%cloud_inhom_separation_factor = cloud_inhom_separation_factor
+    this%cloud_separation_scale_surface = cloud_separation_scale_surface
+    this%cloud_separation_scale_toa = cloud_separation_scale_toa
+    this%cloud_separation_scale_power = cloud_separation_scale_power
+    this%high_inv_effective_size = high_inv_effective_size
+    this%middle_inv_effective_size = middle_inv_effective_size
+    this%low_inv_effective_size = low_inv_effective_size
+
+  end subroutine read_config_from_namelist          
+
+end module setup_config_from_lmdz
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/Makefile
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/Makefile	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/Makefile	(revision 4853)
@@ -111,2 +111,4 @@
 
 radiation_general_cloud_optics.o: radiation_config.o radiation_cloud.o radiation_thermodynamics.o radiation_constants.o
+
+*.o: ecrad_config.h
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics.F90	(revision 4853)
@@ -19,4 +19,6 @@
 !   2022-11-22  P. Ukkonen / R. Hogan  Optimizations to enhance vectorization
 
+#include "ecrad_config.h"
+
 module radiation_aerosol_optics
 
@@ -96,5 +98,9 @@
     use parkind1,                      only : jprb
     use yomhook,                       only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi,          only : netcdf_file
+#else
     use easy_netcdf,                   only : netcdf_file
+#endif
     use radiation_config,              only : config_type
     use radiation_aerosol_optics_data, only : aerosol_optics_type
@@ -341,5 +347,9 @@
     use parkind1,                      only : jprb
     use yomhook,                       only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi,          only : netcdf_file
+#else
     use easy_netcdf,                   only : netcdf_file
+#endif
     use radiation_config,              only : config_type
     use radiation_aerosol_optics_data, only : aerosol_optics_type
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_data.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_data.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_data.F90	(revision 4853)
@@ -17,4 +17,5 @@
 !   2018-04-20  A. Bozzo  Read optical properties at selected wavelengths
 
+#include "ecrad_config.h"
 
 module radiation_aerosol_optics_data
@@ -157,5 +158,9 @@
 
     use yomhook,              only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
     use easy_netcdf,          only : netcdf_file
+#endif
     use radiation_io,         only : nulerr, radiation_abort
 
@@ -401,6 +406,6 @@
   subroutine save_aerosol_optics(this, file_name, iverbose)
 
-    use yomhook,     only : lhook, dr_hook, jphook
-    use easy_netcdf, only : netcdf_file
+    use yomhook,              only : lhook, dr_hook, jphook
+    use easy_netcdf,          only : netcdf_file
 
     class(aerosol_optics_type), intent(inout) :: this
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_description.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_description.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_aerosol_optics_description.F90	(revision 4853)
@@ -13,4 +13,6 @@
 ! Email:   r.j.hogan@ecmwf.int
 !
+
+#include "ecrad_config.h"
 
 module radiation_aerosol_optics_description
@@ -60,4 +62,7 @@
     logical, allocatable :: is_preferred_philic(:)
 
+    ! Verbosity level
+    integer :: iverbose
+    
   contains
     procedure :: read
@@ -75,5 +80,9 @@
 
     use yomhook,              only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
     use easy_netcdf,          only : netcdf_file
+#endif
 
     class(aerosol_optics_description_type), intent(inout) :: this
@@ -84,5 +93,5 @@
     type(netcdf_file)  :: file
 
-    real(jphook) :: hook_handle
+    real(jphook)       :: hook_handle
 
     if (lhook) call dr_hook('radiation_aerosol_optics_description:load',0,hook_handle)
@@ -108,4 +117,10 @@
     call file%close()
 
+    if (present(iverbose)) then
+      this%iverbose = iverbose
+    else
+      this%iverbose = 3
+    end if
+    
     if (lhook) call dr_hook('radiation_aerosol_optics_description:load',1,hook_handle)
 
@@ -124,5 +139,6 @@
 
     use yomhook,              only : lhook, dr_hook, jphook
-
+    use radiation_io,         only : nulout, nulerr, radiation_abort
+    
     class(aerosol_optics_description_type), intent(inout) :: this
     character(len=2), intent(in) :: code_str
@@ -132,5 +148,7 @@
     integer :: ja
 
-    real(jphook) :: hook_handle
+    logical :: is_found, is_philic, is_phobic
+
+    real(jphook)         :: hook_handle
 
     if (lhook) call dr_hook('radiation_aerosol_optics_description:preferred_optical_model',0,hook_handle)
@@ -138,6 +156,11 @@
     ! Check for empty string
     if (optical_model_str == ' ') then
+      if (lhook) call dr_hook('radiation_aerosol_optics_description:preferred_optical_model',1,hook_handle)
       return
     end if
+
+    is_found  = .false.
+    is_philic = .false.
+    is_phobic = .false.
     
     ! Loop over hydrophilic types
@@ -145,7 +168,9 @@
       ! Check if we have a match
       if (to_string(this%code_philic(:,ja)) == code_str &
-           &  .and. to_string(this%optical_model_philic(1:len(optical_model_str),ja)) &
+           &  .and. trim(to_string(this%optical_model_philic(:,ja))) &
            &          == optical_model_str) then
         this%is_preferred_philic(ja) = .true.
+        is_found  = .true.
+        is_philic = .true.
       end if
     end do
@@ -153,14 +178,33 @@
     do ja = 1,size(this%bin_phobic)
       if (to_string(this%code_phobic(:,ja)) == code_str &
-           &  .and. to_string(this%optical_model_phobic(1:len(optical_model_str),ja)) &
+           &  .and. trim(to_string(this%optical_model_phobic(:,ja))) &
            &          == optical_model_str) then
         this%is_preferred_phobic(ja) = .true.
+        is_found  = .true.
+        is_phobic = .true.
       end if
     end do
 
+    if (.not. is_found) then
+      write(nulerr,'(a,a2,a,a,a)') '*** Error: Preferred "', code_str ,'" aerosol optical model "', &
+           &  trim(optical_model_str), '" not found in file'
+      call radiation_abort()
+    else if (this%iverbose > 2) then
+      write(nulout,'(a,a2,a,a,a)',advance='no') 'Preferred "', code_str, '" aerosol optical model set to "', &
+           &  trim(optical_model_str), '" ('
+      if (is_phobic) then
+        write(nulout,'(a)',advance='no') ' hydrophobic'
+      end if
+      if (is_philic) then
+        write(nulout,'(a)',advance='no') ' hydrophilic'
+      end if
+      write(nulout,'(a)') ' )'
+    end if
+    
     if (lhook) call dr_hook('radiation_aerosol_optics_description:preferred_optical_model',1,hook_handle)
 
   end subroutine preferred_optical_model
 
+  
   !---------------------------------------------------------------------
   ! Return the index to the aerosol optical properties corresponding
@@ -179,5 +223,4 @@
     
     use yomhook,              only : lhook, dr_hook, jphook
-    use easy_netcdf,          only : netcdf_file
     use radiation_io,         only : nulout
 
@@ -234,5 +277,5 @@
           end if
           if (present(optical_model_str)) then
-            if (to_string(this%optical_model_philic(1:len(optical_model_str),ja)) &
+            if (trim(to_string(this%optical_model_philic(:,ja))) &
                  &  == optical_model_str) then
               ! Requested optical model matches
@@ -285,5 +328,5 @@
           end if
           if (present(optical_model_str)) then
-            if (to_string(this%optical_model_phobic(1:len(optical_model_str),ja)) &
+            if (trim(to_string(this%optical_model_phobic(:,ja))) &
                  &  == optical_model_str) then
               ! Requested optical model matches
@@ -315,8 +358,9 @@
 
     if (is_ambiguous) then
-      write(nulout,'(a,a2,a,l1,a)') 'Warning: get_index("', code_str, '",', lhydrophilic, &
+      write(nulout,'(a,a2,a,l,a)') 'Warning: radiation_aerosol_optics_description:get_index("', &
+           &  code_str, '",', lhydrophilic, &
            &  ',...) does not unambiguously identify an aerosol optical property index'
     end if
-
+    
     if (lhook) call dr_hook('radiation_aerosol_optics_description:get_index',1,hook_handle)
 
@@ -325,5 +369,7 @@
   !---------------------------------------------------------------------
   ! Utility function to convert an array of single characters to a
-  ! character string (yes Fortran's string handling is a bit rubbish)
+  ! character string (yes Fortran's string handling is a bit
+  ! rubbish). We set NULL characters (ASCII code 0) returned from the
+  ! NetCDF library to spaces, so that TRIM can remove them.
   pure function to_string(arr) result(str)
     character, intent(in)  :: arr(:)
@@ -331,5 +377,10 @@
     integer :: jc
     do jc = 1,size(arr)
-      str(jc:jc) = arr(jc)
+      if (ichar(arr(jc)) == 0) then
+        ! Replace NULL character with a space
+        str(jc:jc) = ' '
+      else
+        str(jc:jc) = arr(jc)
+      end if
     end do
   end function to_string
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud.F90	(revision 4853)
@@ -64,5 +64,5 @@
     ! gridbox area for use in representing 3D effects. This variable
     ! is dimensioned (ncol,nlev).
-    real(jprb), allocatable,  dimension(:,:) :: inv_cloud_effective_size ! m-1
+    real(jprb), allocatable, dimension(:,:) :: inv_cloud_effective_size ! m-1
 
     ! Similarly for the in-cloud heterogeneities, used to compute the
@@ -606,5 +606,4 @@
 
     use yomhook,                  only : lhook, dr_hook, jphook
-!    USE mod_phys_lmdz_para
 
     class(cloud_type), intent(inout) :: this
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_cover.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_cover.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_cover.F90	(revision 4853)
@@ -19,4 +19,6 @@
 !   2020-10-07  R. Hogan  Ensure iobj1 initialized in case of alpha_obj==0
 
+#include "ecrad_config.h"
+
 module radiation_cloud_cover
 
@@ -254,5 +256,5 @@
            &  * (frac(jlev)+frac(jlev+1)-frac(jlev)*frac(jlev+1))
 ! Added for DWD (2020)
-#ifdef __SX__
+#ifdef DWD_VECTOR_OPTIMIZATIONS
     end do
     do jlev = 1,nlev-1
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_generator.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_generator.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_generator.F90	(revision 4853)
@@ -540,9 +540,9 @@
     use radiation_pdf_sampler, only : pdf_sampler_type
     implicit none
-!#if defined(__GFORTRAN__) || defined(__PGI) || defined(__NEC__)
-!#else
-!    !$omp declare simd(sample_from_pdf_simd) uniform(this) &
-!    !$omp linear(ref(fsd)) linear(ref(cdf))
-!#endif
+#if defined(__GFORTRAN__) || defined(__PGI) || defined(__NEC__) || defined(__INTEL_LLVM_COMPILER)
+#else
+    !!$omp declare simd(sample_from_pdf_simd) uniform(this) &
+    !!$omp linear(ref(fsd)) linear(ref(cdf))
+#endif
     type(pdf_sampler_type), intent(in)  :: this
 
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_optics_data.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_optics_data.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_cloud_optics_data.F90	(revision 4853)
@@ -13,4 +13,6 @@
 ! Email:   r.j.hogan@ecmwf.int
 !
+
+#include "ecrad_config.h"
 
 module radiation_cloud_optics_data
@@ -48,6 +50,10 @@
   subroutine setup_cloud_optics(this, liq_file_name, ice_file_name, iverbose)
     
-    use yomhook,  only : lhook, dr_hook, jphook
-    use easy_netcdf, only : netcdf_file
+    use yomhook,              only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
 
     class(cloud_optics_type), intent(inout) :: this
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_config.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_config.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_config.F90	(revision 4853)
@@ -34,4 +34,6 @@
 !
 
+#include "ecrad_config.h"
+
 module radiation_config
 
@@ -202,5 +204,5 @@
     ! more random numbers being generated?  This is the default on NEC
     ! SX.
-#ifdef __SX__
+#ifdef DWD_VECTOR_OPTIMIZATIONS
     logical :: use_vectorizable_generator = .true.
 #else
@@ -276,5 +278,6 @@
 
     ! Codes describing the gas model
-    integer :: i_gas_model = IGasModelIFSRRTMG
+    integer :: i_gas_model_sw = IGasModelIFSRRTMG
+    integer :: i_gas_model_lw = IGasModelIFSRRTMG
 
     ! Optics if i_gas_model==IGasModelMonochromatic.
@@ -702,4 +705,5 @@
     character(511) :: ssi_override_file_name
     character(63)  :: liquid_model_name, ice_model_name, gas_model_name
+    character(63)  :: sw_gas_model_name, lw_gas_model_name
     character(63)  :: sw_solver_name, lw_solver_name, overlap_scheme_name
     character(63)  :: sw_entrapment_name, sw_encroachment_name, cloud_pdf_shape_name
@@ -709,5 +713,5 @@
          &     .false.,.false.,.false.,.false.,.false.,.false.]
     integer :: i_aerosol_type_map(NMaxAerosolTypes) ! More than 256 is an error
-
+    
     logical :: do_nearest_spectral_sw_albedo
     logical :: do_nearest_spectral_lw_emiss
@@ -716,4 +720,5 @@
     integer :: i_sw_albedo_index(NMaxAlbedoIntervals)
     integer :: i_lw_emiss_index (NMaxAlbedoIntervals)
+    integer :: i_gas_model
 
     integer :: iunit ! Unit number of namelist file
@@ -726,5 +731,5 @@
          &  do_surface_sw_spectral_flux, do_lw_derivatives, do_toa_spectral_flux, &
          &  do_lw_aerosol_scattering, do_lw_cloud_scattering, &
-         &  n_regions, directory_name, gas_model_name, &
+         &  n_regions, directory_name, gas_model_name, sw_gas_model_name, lw_gas_model_name, &
          &  ice_optics_override_file_name, liq_optics_override_file_name, &
          &  aerosol_optics_override_file_name, cloud_pdf_override_file_name, &
@@ -815,4 +820,6 @@
     encroachment_scaling = -1.0_jprb
     gas_model_name = '' !DefaultGasModelName
+    sw_gas_model_name = '' !DefaultGasModelName
+    lw_gas_model_name = '' !DefaultGasModelName
     liquid_model_name = '' !DefaultLiquidModelName
     ice_model_name = '' !DefaultIceModelName
@@ -1014,8 +1021,18 @@
          &            'ice_model_name', this%i_ice_model)
 
-    ! Determine gas optics model
+    ! Determine gas optics model(s) - firstly try the generic gas_model_name
+    i_gas_model = -1
     call get_enum_code(gas_model_name, GasModelName, &
-         &            'gas_model_name', this%i_gas_model)
-
+         &            'gas_model_name', i_gas_model)
+    if (i_gas_model > -1) then
+      this%i_gas_model_sw = i_gas_model
+      this%i_gas_model_lw = i_gas_model
+    end if
+    ! ...then the band-specific values
+    call get_enum_code(sw_gas_model_name, GasModelName, &
+         &            'sw_gas_model_name', this%i_gas_model_sw)
+    call get_enum_code(lw_gas_model_name, GasModelName, &
+         &            'lw_gas_model_name', this%i_gas_model_lw)
+   
     ! Determine solvers
     call get_enum_code(sw_solver_name, SolverName, &
@@ -1055,12 +1072,12 @@
     end if
 
-    if (this%i_gas_model == IGasModelIFSRRTMG &
-         & .and. (this%use_general_cloud_optics &
-         &        .or. this%use_general_aerosol_optics)) then
-      if (this%do_sw .and. this%do_cloud_aerosol_per_sw_g_point) then
+    if (this%use_general_cloud_optics .or. this%use_general_aerosol_optics) then
+      if (this%do_sw .and. this%do_cloud_aerosol_per_sw_g_point &
+           &  .and. this%i_gas_model_sw == IGasModelIFSRRTMG) then
         write(nulout,'(a)') 'Warning: RRTMG SW only supports cloud/aerosol/surface optical properties per band, not per g-point'
         this%do_cloud_aerosol_per_sw_g_point = .false.
       end if
-      if (this%do_lw .and. this%do_cloud_aerosol_per_lw_g_point) then
+      if (this%do_lw .and. this%do_cloud_aerosol_per_lw_g_point &
+           &  .and. this%i_gas_model_lw == IGasModelIFSRRTMG) then
         write(nulout,'(a)') 'Warning: RRTMG LW only supports cloud/aerosol/surface optical properties per band, not per g-point'
         this%do_cloud_aerosol_per_lw_g_point = .false.
@@ -1128,5 +1145,5 @@
 
     ! If ecCKD gas optics model is being used set relevant file names
-    if (this%i_gas_model == IGasModelECCKD) then
+    if (this%i_gas_model_sw == IGasModelECCKD .or. this%i_gas_model_lw == IGasModelECCKD) then
 
       ! This gas optics model usually used with general cloud and
@@ -1138,4 +1155,8 @@
         write(nulout,'(a)') 'Warning: ecCKD gas optics model usually used with general aerosol optics'
       end if
+
+    end if
+
+    if (this%i_gas_model_sw == IGasModelECCKD) then
 
       if (len_trim(this%gas_optics_sw_override_file_name) > 0) then
@@ -1153,4 +1174,8 @@
       end if
 
+    end if
+
+    if (this%i_gas_model_lw == IGasModelECCKD) then
+
       if (len_trim(this%gas_optics_lw_override_file_name) > 0) then
         if (this%gas_optics_lw_override_file_name(1:1) == '/') then
@@ -1170,5 +1195,5 @@
 
     if (this%use_spectral_solar_cycle) then
-      if (this%i_gas_model /= IGasModelECCKD) then
+      if (this%i_gas_model_sw /= IGasModelECCKD) then
         write(nulerr,'(a)') '*** Error: solar cycle only available with ecCKD gas optics model'
         call radiation_abort('Radiation configuration error')
@@ -1278,10 +1303,17 @@
     end if
 
-    ! In the monochromatic case we need to override the liquid, ice
-    ! and aerosol models to ensure compatibility
-    if (this%i_gas_model == IGasModelMonochromatic) then
+    if (this%i_gas_model_sw == IGasModelMonochromatic .or. this%i_gas_model_lw == IGasModelMonochromatic) then
+
+      if (this%i_gas_model_sw /= this%i_gas_model_lw) then
+        write(nulerr,'(a,i0)') '*** Error: Monochromatic gas optics model must be used in shortwave and longwave'
+        call radiation_abort('Radiation configuration error')
+      end if
+    
+      ! In the monochromatic case we need to override the liquid, ice
+      ! and aerosol models to ensure compatibility
       this%i_liq_model = ILiquidModelMonochromatic
       this%i_ice_model = IIceModelMonochromatic
       this%use_aerosols = .false.
+      
     end if
 
@@ -1392,6 +1424,8 @@
       call print_logical('  Saving spectral flux profiles', &
            &   'do_save_spectral_flux', this%do_save_spectral_flux)
-      call print_enum('  Gas model is', GasModelName, 'i_gas_model', &
-           &          this%i_gas_model)
+      call print_enum('  Shortwave gas model is', GasModelName, 'i_gas_model_sw', &
+           &          this%i_gas_model_sw)
+      call print_enum('  Longwave gas model is', GasModelName, 'i_gas_model_lw', &
+           &          this%i_gas_model_lw)
       call print_logical('  Aerosols are', 'use_aerosols', this%use_aerosols)
       if (this%use_aerosols) then
@@ -1481,5 +1515,5 @@
              &          'i_solver_sw', this%i_solver_sw)
         
-        if (this%i_gas_model == IGasModelMonochromatic) then
+        if (this%i_gas_model_sw == IGasModelMonochromatic) then
           call print_real('  Shortwave atmospheric optical depth', &
                &   'mono_sw_total_od', this%mono_sw_total_od)
@@ -1502,5 +1536,5 @@
              &          this%i_solver_lw)
 
-        if (this%i_gas_model == IGasModelMonochromatic) then
+        if (this%i_gas_model_lw == IGasModelMonochromatic) then
           if (this%mono_lw_wavelength > 0.0_jprb) then
             call print_real('  Longwave effective wavelength (m)', &
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd.F90	(revision 4853)
@@ -15,4 +15,6 @@
 !
 
+#include "ecrad_config.h"
+
 module radiation_ecckd
 
@@ -105,5 +107,5 @@
 ! Vectorized version of the optical depth look-up performs better on
 ! NEC, but slower on x86
-#ifdef __SX__
+#ifdef DWD_VECTOR_OPTIMIZATIONS
     procedure :: calc_optical_depth => calc_optical_depth_ckd_model_vec
 #else
@@ -125,7 +127,11 @@
   subroutine read_ckd_model(this, filename, iverbose)
 
-    use easy_netcdf,  only : netcdf_file
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
     !use radiation_io, only : nulerr, radiation_abort
-    use yomhook,      only : lhook, dr_hook, jphook
+    use yomhook,              only : lhook, dr_hook, jphook
 
     class(ckd_model_type), intent(inout) :: this
@@ -166,6 +172,4 @@
     this%d_log_pressure = log(pressure_lut(2)) - this%log_pressure1
     call file%get('temperature', temperature_full)
-    ! AI oct 2023 ajout pour le double appel de ecrad    
-    if (allocated(this%temperature1)) deallocate(this%temperature1)
     allocate(this%temperature1(this%npress));
     this%temperature1 = temperature_full(:,1)
@@ -200,5 +204,4 @@
     ! Read gases
     call file%get('n_gases', this%ngas)
-    if (allocated(this%single_gas)) deallocate(this%single_gas)
     allocate(this%single_gas(this%ngas))
     call file%get_global_attribute('constituent_id', constituent_id)
@@ -292,7 +295,11 @@
   subroutine read_spectral_solar_cycle(this, filename, iverbose, use_updated_solar_spectrum)
 
-    use easy_netcdf,  only : netcdf_file
-    use radiation_io, only : nulout, nulerr, radiation_abort
-    use yomhook,      only : lhook, dr_hook, jphook
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
+    use radiation_io,         only : nulout, nulerr, radiation_abort
+    use yomhook,              only : lhook, dr_hook, jphook
 
     ! Reference total solar irradiance (W m-2)
@@ -450,5 +457,5 @@
   subroutine calc_optical_depth_ckd_model(this, ncol, nlev, istartcol, iendcol, nmaxgas, &
        &  pressure_hl, temperature_fl, mole_fraction_fl, &
-       &  optical_depth_fl, rayleigh_od_fl)
+       &  optical_depth_fl, rayleigh_od_fl, concentration_scaling)
 
     use yomhook,             only : lhook, dr_hook, jphook
@@ -466,4 +473,6 @@
     ! Gas mole fractions at full levels (mol mol-1), dimensioned (ncol,nlev,nmaxgas)
     real(jprb),            intent(in)  :: mole_fraction_fl(ncol,nlev,nmaxgas)
+    ! Optional concentration scaling of each gas
+    real(jprb), optional,  intent(in)  :: concentration_scaling(nmaxgas)
     
     ! Output variables
@@ -486,4 +495,5 @@
 
     real(jprb) :: multiplier(nlev), simple_multiplier(nlev), global_multiplier, temperature1
+    real(jprb) :: scaling
 
     ! Indices and weights in temperature, pressure and concentration interpolation
@@ -547,4 +557,8 @@
             multiplier = simple_multiplier * mole_fraction_fl(jcol,:,igascode)
 
+            if (present(concentration_scaling)) then
+              multiplier = multiplier * concentration_scaling(igascode)
+            end if
+            
             do jlev = 1,nlev
               optical_depth_fl(:,jlev,jcol) = optical_depth_fl(:,jlev,jcol) &
@@ -557,6 +571,14 @@
           case (IConcDependenceRelativeLinear)
             molar_abs => this%single_gas(jgas)%molar_abs
-            multiplier = simple_multiplier  * (mole_fraction_fl(jcol,:,igascode) &
-                 &                            - single_gas%reference_mole_frac)
+
+            if (present(concentration_scaling)) then
+              multiplier = simple_multiplier &
+                   &  * (mole_fraction_fl(jcol,:,igascode)*concentration_scaling(igascode) &
+                   &     - single_gas%reference_mole_frac)
+            else
+              multiplier = simple_multiplier  * (mole_fraction_fl(jcol,:,igascode) &
+                   &                            - single_gas%reference_mole_frac)
+            end if
+            
             do jlev = 1,nlev
               optical_depth_fl(:,jlev,jcol) = optical_depth_fl(:,jlev,jcol) &
@@ -579,4 +601,11 @@
 
           case (IConcDependenceLUT)
+
+            if (present(concentration_scaling)) then
+              scaling = concentration_scaling(igascode)
+            else
+              scaling = 1.0_jprb
+            end if
+            
             ! Logarithmic interpolation in concentration space
             molar_abs_conc => this%single_gas(jgas)%molar_abs_conc
@@ -584,5 +613,5 @@
             do jlev = 1,nlev
               ! Take care of mole_fraction == 0
-              log_conc = log(max(mole_fraction_fl(jcol,jlev,igascode), mole_frac1))
+              log_conc = log(max(mole_fraction_fl(jcol,jlev,igascode)*scaling, mole_frac1))
               cindex1  = (log_conc - single_gas%log_mole_frac1) / single_gas%d_log_mole_frac
               cindex1  = 1.0_jprb + max(0.0_jprb, min(cindex1, single_gas%n_mole_frac-1.0001_jprb))
@@ -601,5 +630,5 @@
             do jlev = 1,nlev
               optical_depth_fl(:,jlev,jcol) = optical_depth_fl(:,jlev,jcol) &
-                   &  + (simple_multiplier(jlev) * mole_fraction_fl(jcol,jlev,igascode)) * ( &
+                   &  + (simple_multiplier(jlev) * mole_fraction_fl(jcol,jlev,igascode) * scaling) * ( &
                    &      (cw1(jlev) * tw1(jlev) * pw1(jlev)) * molar_abs_conc(:,ip1(jlev),it1(jlev),ic1(jlev)) &
                    &     +(cw1(jlev) * tw1(jlev) * pw2(jlev)) * molar_abs_conc(:,ip1(jlev)+1,it1(jlev),ic1(jlev)) &
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_gas.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_gas.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_gas.F90	(revision 4853)
@@ -14,4 +14,6 @@
 ! License: see the COPYING file for details
 !
+
+#include "ecrad_config.h"
 
 module radiation_ecckd_gas
@@ -82,5 +84,9 @@
   subroutine read_ckd_gas(this, file, gas_name, i_gas_code)
 
-    use easy_netcdf, only : netcdf_file
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
 
     class(ckd_gas_type), intent(inout) :: this
